RollMaster = LibStub("AceAddon-3.0"):NewAddon("RollMaster", "AceConsole-3.0", "AceEvent-3.0")
local lastTime
local NUM_BUTTONS = 0
local NUM_ITEMBUTTONS = 0
local BUTTON_HEIGHT = 18
local BUTTON_WIDTH = 195
local RollMaster_RollCollector = {}
local highestRoller = {}
local highestRoll = 0
local nextItem
local buttons = {}
local names = {}
local rolls = {}
local itemsForRoll = {}
local alreadyRolled = {}
local itemButtons = {}
local items = {}
local startTimer
local rollStarted
local three = false
local two = false
local one = false
local chatMethod
local Winner
local winnerRoll
local raidRollWinner

function RollMaster:OnInitialize()

end


function RollMaster:OnEnable()
	self:RegisterEvent("CHAT_MSG_SYSTEM")
	self:RegisterEvent("LOOT_OPENED")
	self:RegisterEvent("LOOT_CLOSED")
	lastTime = GetTime()
end

local function button_clear()
	for i = 1, NUM_BUTTONS do
		buttons[i]:ClearAllPoints()
		buttons[i]:Hide()
	end
	NUM_BUTTONS = 0
	table.wipe(RollMaster_RollCollector)
	table.wipe(buttons)
	table.wipe(names)
	table.wipe(rolls)
	table.wipe(alreadyRolled)
	table.wipe(highestRoller)																
	RollMaster_RollFrame:SetHeight(20)
end

local RollMaster_TopFrame = CreateFrame("Frame", "RollMaster_TopFrame", UIParent)
	RollMaster_TopFrame:SetWidth(200)	
	RollMaster_TopFrame:SetHeight(80)
	RollMaster_TopFrame:SetPoint("CENTER", UIParent)
	RollMaster_TopFrame:RegisterForDrag("LeftButton")	
	RollMaster_TopFrame:EnableMouse(true)
	RollMaster_TopFrame:SetMovable(true)
	RollMaster_TopFrame:SetScript("OnDragStart", function(self) self:StartMoving() end)
	RollMaster_TopFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	RollMaster_TopFrame:SetScript("OnUpdate", function()
																				if GetTime() - lastTime >= 0.5 then
																					lastTime = GetTime()
																					if rollStarted then
																						if GetTime() - startTimer >= 7 then 
																							if IsInRaid()  and UnitIsGroupLeader("PLAYER") then
																								SendChatMessage("Rolls for ".. nextItem.. " has ended!", "RAID_WARNING")
																							elseif IsInRaid() then
																								SendChatMessage("Rolls for ".. nextItem.. " has ended!", "RAID")
																							else
																								SendChatMessage("Rolls for ".. nextItem.. " has ended!", "PARTY")
																							end
																							if table.getn(highestRoller) >= 2 then
																								RollMaster_StartRollText:SetText("|cffffffffReroll")
																							elseif table.getn(highestRoller) == 0 and RollMaster_StartRollText:GetText() == "|cffffffffOffspec" then
																								RollMaster_StartRollText:SetText("|cffffffffRaid Roll!")
																							elseif table.getn(highestRoller) == 0 then
																								RollMaster_StartRollText:SetText("|cffffffffOffspec")
																							else
																								RollMaster_Award:Show()
																								RollMaster_StartRoll:Hide()
																							end
																							startTimer = 0
																							rollStarted = false
																							one = false
																							two = false
																							three = false
																						
																						elseif GetTime() - startTimer >= 6 and not one and rollStarted then 
																							if IsInRaid()  and UnitIsGroupLeader("PLAYER") then
																								SendChatMessage("Roll: "..nextItem.." - 1 second left!", "RAID_WARNING")
																							elseif IsInRaid() then
																								SendChatMessage("Roll: "..nextItem.." - 1 second left!", "RAID")
																							else
																								SendChatMessage("Roll: "..nextItem.." - 1 second left!", "PARTY")
																							end
																							one = true
																						elseif GetTime() - startTimer >= 5 and not two and rollStarted then 
																							if IsInRaid()  and UnitIsGroupLeader("PLAYER") then
																								SendChatMessage("Roll: "..nextItem.." - 2 second left!", "RAID_WARNING")
																							elseif IsInRaid() then
																								SendChatMessage("Roll: "..nextItem.." - 2 second left!", "RAID")
																							else
																								SendChatMessage("Roll: "..nextItem.." - 2 second left!", "PARTY")
																							end
																							two = true
																						elseif GetTime() - startTimer >= 4 and not three and rollStarted then 
																							if IsInRaid()  and UnitIsGroupLeader("PLAYER") then
																								SendChatMessage("Roll: "..nextItem.." - 3 second left!", "RAID_WARNING")
																							elseif IsInRaid() then
																								SendChatMessage("Roll: "..nextItem.." - 3 second left!", "RAID")
																							else
																								SendChatMessage("Roll: "..nextItem.." - 3 second left!", "PARTY")
																							end
																							three = true
																						end
																					end
																				end
																			end)
	RollMaster_TopFrame_Texture = RollMaster_TopFrame:CreateTexture()
	RollMaster_TopFrame_Texture:SetTexture("Interface\\AddOns\\RollMaster\\Media\\TopFrame")
	RollMaster_TopFrame_Texture:SetAllPoints(RollMaster_TopFrame)

local function OnEnter(self)
	if nextItem then
	  GameTooltip:SetOwner(self)
	  GameTooltip:SetPoint("LEFT", RollMaster_Item, "RIGHT")
	  GameTooltip:SetHyperlink(nextItem)
	  GameTooltip:Show()
	end
end	

local function OnLeave(self)

  GameTooltip:Hide()

end
	
local RollMaster_Item = CreateFrame("Button", "RollMaster_Item", RollMaster_TopFrame)
	RollMaster_Item:SetPoint("TOPLEFT", RollMaster_TopFrame, "TOPLEFT", 5, -5)
	RollMaster_Item:SetSize(50, 50)
	RollMaster_Item:SetScript("OnEnter", OnEnter)
	RollMaster_Item:SetScript("OnLeave", OnLeave)
	RollMaster_Item:SetNormalTexture("Interface\\BUTTONS\\UI-EmptySlot")
	
local RollMaster_StartRoll = CreateFrame("Button", "RollMaster_StartRoll", RollMaster_TopFrame)
	RollMaster_StartRoll:SetPoint("TOPLEFT", RollMaster_Item, "TOPRIGHT", 5, -5)
	RollMaster_StartRoll:SetSize(80, 20)
	RollMaster_StartRoll:SetScript("OnClick", function()
																		if nextItem then
																			if IsInRaid()  and UnitIsGroupLeader("PLAYER") then
																				chatMethod = "RAID_WARNING"
																			elseif IsInRaid() then
																				chatMethod = "RAID"
																			else
																				chatMethod = "PARTY"
																			end
																			if RollMaster_StartRollText:GetText() ~= "|cffffffffPick an Item!" then 
																				if  RollMaster_StartRollText:GetText() == "|cffffffffRaid Roll!" then
																					local name
																					local index
																					local rollNum
																					for i = 1, GetNumLootItems() do
																						if nextItem == GetLootSlotLink(i) then
																							index = i
																						end
																					end
																					for i = 1, GetNumGroupMembers() do
																						if GetMasterLootCandidate(index, i) then 
																							local name = GetMasterLootCandidate(index, i)
																							if IsInRaid() then 
																								SendChatMessage(name.." = " ..i, "RAID")
																							else
																								SendChatMessage(name.." = " ..i, "PARTY")
																							end
																							rollNum = i
																						end
																					end
																					RandomRoll(1, rollNum)
																				elseif table.getn(highestRoller) >= 2 then
																					SendChatMessage("Rerolls for ".. nextItem.. " has started! You have 7 seconds to /roll!", chatMethod)
																					startTimer = GetTime()
																					rollStarted = true
																				elseif RollMaster_StartRollText:GetText() == "|cffffffffOffspec" then
																					SendChatMessage("Offspec rolls for "..nextItem.." has started! You have 7 seconds to /roll!", chatMethod)
																					startTimer = GetTime()
																					rollStarted = true
																				else
																					SendChatMessage("Mainspec rolls for ".. nextItem.. " has started! You have 7 seconds to /roll!", chatMethod)
																					startTimer = GetTime()
																					rollStarted = true
																				end
																			end
																		end
																	end)
	local RollMaster_StartRollText = RollMaster_StartRoll:CreateFontString("RollMaster_StartRollText", nil, "GameFontNormal")
		RollMaster_StartRollText:SetText("|cffffffffPick an Item!")
		RollMaster_StartRollText:SetPoint("CENTER")
	RollMaster_StartRoll:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\TopFrame")
	RollMaster_StartRoll:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")

local RollMaster_ItemFrame = CreateFrame("Frame", "RollMaster_ItemFrame", RollMaster_TopFrame)
	RollMaster_ItemFrame:SetWidth(200)	
	RollMaster_ItemFrame:SetHeight(table.getn(itemsForRoll)*BUTTON_HEIGHT + 20)	
	RollMaster_ItemFrame:SetPoint("TOPLEFT", RollMaster_TopFrame, "TOPRIGHT")
	RollMaster_ItemFrame.texture = RollMaster_ItemFrame:CreateTexture()
	RollMaster_ItemFrame.texture:SetTexture("Interface\\AddOns\\RollMaster\\Media\\TopFrame")
	RollMaster_ItemFrame.texture:SetAllPoints(RollMaster_ItemFrame)

local RollMaster_RollFrame = CreateFrame("Frame", "RollMaster_RollFrame", RollMaster_TopFrame) --, "UIPanelDialogTemplate")
	RollMaster_RollFrame:SetWidth(200)
	RollMaster_RollFrame:SetHeight(20)
	RollMaster_RollFrame:SetPoint("TOP", RollMaster_TopFrame, "BOTTOM")
	RollMaster_RollFrame_RollTexture = RollMaster_RollFrame:CreateTexture()
	RollMaster_RollFrame_RollTexture:SetTexture("Interface\\AddOns\\RollMaster\\Media\\GridFrame")
	RollMaster_RollFrame_RollTexture:SetAllPoints(RollMaster_RollFrame)
	
local RollMaster_TopButton = CreateFrame("Button", "RollMaster_TopButton", RollMaster_RollFrame)
	RollMaster_TopButton:SetPoint("TOP", RollMaster_RollFrame, "TOP", 0, -2)
	RollMaster_TopButton:SetSize(BUTTON_WIDTH, BUTTON_HEIGHT)
	RollMaster_TopButton:SetScript("OnClick", function() 
																			button_clear()
																		end)

local RollMaster_number = RollMaster_TopButton:CreateFontString("RollMaster_number", nil, "GameFontNormal")
	RollMaster_number:SetText("|cffffff66#")
	RollMaster_number:SetPoint("LEFT", 5, 0)

local RollMaster_Name = RollMaster_TopButton:CreateFontString("RollMaster_name.", nil, "GameFontNormal")
	RollMaster_Name:SetPoint("LEFT", RollMaster_TopButton, "LEFT", 20, 0)
	RollMaster_Name:SetText("|cFFFFFFFFName:")
	
local RollMaster_Roll = RollMaster_TopButton:CreateFontString("RollMaster_roll", nil, "GameFontNormal")
	RollMaster_Roll:SetPoint("RIGHT", RollMaster_TopButton, "RIGHT", -3, 0)
	RollMaster_Roll:SetText("|cFFFFFFFFRoll")
	RollMaster_ItemFrame:Hide()

local function createItemButtons()
	for i = 1, table.getn(itemsForRoll), 1 do
		local button = CreateFrame("Button", "RollMaster_ItemButton"..NUM_ITEMBUTTONS + 1, RollMaster_ItemFrame)
		RollMaster_ItemFrame:SetHeight((NUM_ITEMBUTTONS + 1) *BUTTON_HEIGHT + 20)
		if NUM_ITEMBUTTONS == 0 then
			button:SetPoint("TOP",  RollMaster_ItemFrame, "TOP", 0, -10)
			NUM_ITEMBUTTONS = NUM_ITEMBUTTONS + 1
		else
			button:SetPoint("TOP", itemButtons[NUM_ITEMBUTTONS], "BOTTOM")
			NUM_ITEMBUTTONS = NUM_ITEMBUTTONS + 1
		end
		button:SetSize(150, BUTTON_HEIGHT)
		button:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\Button")
		button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
		button:Show()
		button:SetScript("OnClick", function()
														for i = 1, NUM_ITEMBUTTONS do
															itemButtons[i]:Show()
														end
														button:Hide()
														local texture = select(10, GetItemInfo(itemsForRoll[i]))
														RollMaster_Item:SetNormalTexture(texture)
														nextItem = itemsForRoll[i]
														RollMaster_StartRollText:SetText("|cFFFFFFFFStart Rolls!")
													end)
		local item = button:CreateFontString("RollMaster_item"..i, nil, "GameFontNormal")
			item:SetText(itemsForRoll[i])
			item:SetPoint("CENTER")
		itemButtons[NUM_ITEMBUTTONS] = button
		items[NUM_ITEMBUTTONS] = item
	end
end
	
local function lootAwarded()
	RollMaster_Item:SetNormalTexture("Interface\\BUTTONS\\UI-EmptySlot")
	RollMaster_Award:Hide()
	RollMaster_StartRoll:Show()
	RollMaster_StartRollText:SetText("|cffffffffPick an Item!")
	table.wipe(highestRoller)
	highestRoll = 0
	for i = 1, NUM_ITEMBUTTONS do
		itemButtons[i]:ClearAllPoints()
		itemButtons[i]:Hide()
	end
	--[[
	if not rollStarted then
		nextItem = nil
	end
	]]
	winner = nil
	NUM_ITEMBUTTONS = 0
	createItemButtons()
	button_clear()
end

local RollMaster_Award = CreateFrame("Button", "RollMaster_Award", RollMaster_TopFrame)
	RollMaster_Award:SetPoint("TOP", RollMaster_StartRoll, "BOTTOM", 0, -5)
	RollMaster_Award:SetSize(80, 20)
	local RollMaster_AwardText = RollMaster_Award:CreateFontString("RollMaster_AwardText", nil, "GameFontNormal")
		RollMaster_AwardText:SetText("|cffffffffAward Loot!")
		RollMaster_AwardText:SetPoint("CENTER")
	RollMaster_Award:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\TopFrame")
	RollMaster_Award:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
	RollMaster_Award:SetScript("OnClick", function()
																		if nextItem and not rollStarted then
																			if IsInRaid()  and UnitIsGroupLeader("PLAYER") then
																				chatMethod = "RAID_WARNING"
																			elseif IsInRaid() then
																				chatMethod = "RAID"
																			else
																				chatMethod = "PARTY"
																			end
																			local name
																			local index
																			if winner then
																				for i = 1, GetNumLootItems() do
																					if nextItem == GetLootSlotLink(i) then
																						index = i
																					end
																				end
																				for i = 1, 40 do
																					name = select(1, GetMasterLootCandidate(index, i))
																					if name then
																						if winner:match(name) then
																							SendChatMessage(name.. " have won the rolls for ".. nextItem.. "! Congratulation!", chatMethod)
																							GiveMasterLoot(index, i)
																							lootAwarded()
																						end
																					end
																				end
																			elseif table.getn(highestRoller) == 1 then																				
																				
																				for i = 1, GetNumLootItems() do
																					if nextItem == GetLootSlotLink(i) then
																						index = i
																					end
																				end
																				for i = 1, GetNumGroupMembers() do
																					if highestRoller[1] and highestRoller[1] == GetMasterLootCandidate(index, i) then
																						if nextItem and highestRoller[1] and chatMethod then
																							SendChatMessage(highestRoller[1].. " have won the rolls for ".. nextItem.. "! Congratulation!", chatMethod)
																						end
																						GiveMasterLoot(index, i)
																						lootAwarded()
																					end
																				end
																			elseif table.getn(highestRoller) >= 2 then
																				print("Reroll required - 2 or more people at max roll")
																			else
																				print("No one rolled.")
																			end																			
																		end
																	end)
RollMaster_Award:Hide()

local function createButton(name, roll, minRoll, maxRoll)
	if name and maxRoll == "100" and minRoll == "1" then
		local button = CreateFrame("Button", "RollMaster_button"..NUM_BUTTONS + 1, RollMaster_RollFrame)
		RollMaster_RollFrame:SetHeight(BUTTON_HEIGHT * (NUM_BUTTONS + 1) + 25)
		RollMaster_RollFrame:Show()
		if NUM_BUTTONS == 0 then
			button:SetPoint("TOP", RollMaster_RollFrame, "TOP", 0, -20)
			NUM_BUTTONS = 1
		else
			button:SetPoint("TOP", buttons[NUM_BUTTONS], "BOTTOM")
			NUM_BUTTONS = NUM_BUTTONS + 1
		end
		button:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\Button")
		button:SetHighlightTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
		button:SetSize(BUTTON_WIDTH, BUTTON_HEIGHT)
		
		local number = button:CreateFontString("RollMaster_number"..NUM_BUTTONS, nil, "GameFontNormal")
		number:SetText("|cffffffff[".. NUM_BUTTONS .."]")
		number:SetPoint("LEFT")
		
		local Name = button:CreateFontString("RollMaster_name."..NUM_BUTTONS, nil, "GameFontNormal")
		Name:SetPoint("LEFT", button, "LEFT", 20, 0)
		
		local Roll = button:CreateFontString("RollMaster_roll"..NUM_BUTTONS, nil, "GameFontNormal")
		Roll:SetPoint("RIGHT", button, "RIGHT", -10, 0)
		button:Show()
		local highlight
		button:SetScript("OnClick", function() 
														if highlight then
															button:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\Button")
															highlight = false
															winner = nil
															winnerRoll = nil
														else
															for i = 1, NUM_BUTTONS do
																buttons[i]:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\Button")
															end
															button:SetNormalTexture("Interface\\BUTTONS\\UI-Listbox-Highlight")
															winner = Name:GetText()
															winnerRoll = Roll:GetText()
															highlight = true
														end
													end)
		buttons[NUM_BUTTONS] = button
		rolls[NUM_BUTTONS] = Roll
		names[NUM_BUTTONS] = Name
		
		local buttonCount = 1
		
		for i=100,1,-1 do
			if RollMaster_RollCollector[""..i..""] then
				for k,v in ipairs(RollMaster_RollCollector[""..i..""]) do
					if RollMaster_RollCollector[""..i..""] then
						local class
						local classColor
						for i = 1, GetNumGroupMembers() do
							if select(1, UnitName("PLAYER")) == v then
								class = select(2, UnitClass("PLAYER"))
								name = GetUnitName("PLAYER", true)
							elseif select(1, UnitName("party"..i)) == v then
								class = select(2, UnitClass("party"..i))
								name = GetUnitName("party"..i, true)
							elseif UnitName("raid"..i) == v then
								class = select(2, UnitClass("raid"..i))
								name = GetUnitName("raid"..i, true)
							end
						end
						if class then
							classColor = (RAID_CLASS_COLORS[class].colorStr)
						else
							classColor = "FFFFFF00"
						end
						if classColor then
							names[buttonCount]:SetText("|c"..classColor..name)
							rolls[buttonCount]:SetText("|c"..classColor.. i)
						else
							names[buttonCount]:SetText(name)
							rolls[buttonCount]:SetText(i)
						end
						buttonCount = buttonCount + 1
					end
				end
			end
		end
	end
end


function RollMaster:LOOT_OPENED()
	local lootMethod, masterLooter, _ = GetLootMethod()
	if lootMethod == "master" and masterLooter == 0 then
		for i = 1, 10 do
			local quantity
			local itemLink = GetLootSlotLink(i)
			if itemLink then
				quantity = select(3, GetItemInfo(itemLink))
			end
			if itemLink and quantity and quantity >= GetLootThreshold() then
				table.insert(itemsForRoll, 1, itemLink)
				RollMaster_TopFrame:Show()
			end
		end
		RollMaster_ItemFrame:Show()
		createItemButtons()
	end
end

function RollMaster:LOOT_CLOSED()
	table.wipe(itemsForRoll)
	for i = 1, NUM_ITEMBUTTONS do
		itemButtons[i]:ClearAllPoints()
		itemButtons[i]:Hide()
	end
	
	if not rollStarted then
		nextItem = nil
	end
	NUM_ITEMBUTTONS = 0
	RollMaster_TopFrame:Hide()
	RollMaster_Item:SetNormalTexture("Interface\\AddOns\\RollMaster\\Media\\TopFrame")
end

function RollMaster:CHAT_MSG_SYSTEM(event, ...)
	local arg1 = select(1, ...)
	if arg1 then
		local name, roll, minRoll, maxRoll = arg1:match("^(.+) rolls (%d+) %((%d+)%-(%d+)%)$")
		if name then
			local rollNum = tonumber(roll)
			local nameServer
			
			for i = 1, GetNumGroupMembers() do
				if select(1, UnitName("PLAYER")) == name then
					nameServer = GetUnitName("PLAYER", true)
				elseif select(1, UnitName("party"..i)) == name then
					nameServer = GetUnitName("party"..i, true)
				elseif UnitName("raid"..i) == name then
					nameServer = GetUnitName("raid"..i, true)
				end
			end
			local index
			if nextItem then
				for i = 1, GetNumLootItems() do
					if nextItem == GetLootSlotLink(i) then
						index = i
					end
				end
			end
			if RollMaster_StartRollText:GetText() == "|cffffffffRaid Roll!" and name == select(1, UnitName("PLAYER")) then
				table.wipe(highestRoller)
				highestRoll = 0
				local name = GetMasterLootCandidate(index, rollNum)
				winner = name
				table.insert(highestRoller, 1, name)
				RollMaster_Award:Show()
				RollMaster_StartRoll:Hide()						
			elseif rollStarted then
				for i = 1, GetNumGroupMembers() do
					if name == GetMasterLootCandidate(index, i) then
						if alreadyRolled[name] then
							if IsInRaid() then
								SendChatMessage(nameServer.. " rolled more then once. Second rolls will be ignored!", "RAID")
							else
								SendChatMessage(nameServer.. " rolled more then once. Second rolls will be ignored!", "PARTY")
							end
							roll = nil
						else
							alreadyRolled[name] = true
						end
						if roll then
							if rollNum >= highestRoll then
								if rollNum ~= highestRoll then
									table.wipe(highestRoller)
									highestRoll = rollNum
								end
								table.insert(highestRoller, 1, nameServer)
							end
						end				
						if roll then					
							if RollMaster_RollCollector[roll]==nil then
								RollMaster_RollCollector[roll] = {} --more than one person can roll the same number that is why the table
							end
							if minRoll == "1" and maxRoll == "100" then
								table.insert(RollMaster_RollCollector[roll], 1, 0)
								RollMaster_RollCollector[roll][1] = name
							end
							createButton(name, roll, minRoll, maxRoll)
						end
					end
				end
			end
		end
	end
end

RollMaster_TopFrame:Hide()
